package foliocrawl;

import folios.FolioIterator;
import folios.FolioManager;

import intradoc.common.ServiceException;

import intradoc.data.DataBinder;
import intradoc.data.DataException;

import intradoc.data.DataResultSet;

import intradoc.data.ResultSet;

import intradoc.server.ServiceHandler;


import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

public class FolioCrawlServiceHandler extends ServiceHandler {
  public FolioCrawlServiceHandler() {
  }
  
  public void doFolioCrawl() throws ServiceException, DataException {
    // crawl the folio in question
    // System.out.println("... in Folio Crawl Service Handler - root node is "+m_binder.getActiveAllowMissing("RootNode"));
    // create a Folio Manager if it doesn't exist
    FolioManager m_manager =(FolioManager)m_service.getCachedObject("FolioManager");
    if(m_manager== null)
    {
      m_manager = new FolioManager();
      m_manager.init(m_workspace,m_service);
      m_service.setCachedObject("FolioManager",m_manager);
    }
    String[] folioResultSetColumns = new String[] {"id", "type", "level", "title", "description", "dDocTitle", "dDocName", "dRevLabel", "dID", "dDocType", "dDocAuthor", "docURL", "thumbnailURL", "dFormat"};
    DataResultSet folioResultSet = new DataResultSet(folioResultSetColumns);
    // created the interator call back
    FolioCrawlIterator callback = new FolioCrawlIterator();
    // set up the options for the Iterator
    Map options = new HashMap();
    options.put("folioResultSet",folioResultSet);
    FolioIterator m_iterator = new FolioIterator();
    // get the folio data binder the service loaded
    DataBinder folioDataBinder = (DataBinder) m_service.getCachedObject("FolioObject");
    /***
     * Text code to dump the result sets from the folioDataBinder
    Enumeration e = folioDataBinder.getResultSetList();
    while(e.hasMoreElements()) {
      String rsName = (String)e.nextElement();
      ResultSet rs = folioDataBinder.getResultSet(rsName);
      System.out.println("... in Folio Crawl Service Handler and have FolioObject Result Set: "+rsName);
      System.out.println("...   with "+rs.getNumFields()+" columns");
      if(rs.first()) {
        // dump the result set
        for(int i = 0; i<rs.getNumFields(); i++) {
          System.out.print("  |  "+rs.getFieldName(i));
        }
        System.out.println("");
        while(rs.isRowPresent()) {
          for(int i = 0; i<rs.getNumFields(); i++) {
            System.out.print("  |  "+rs.getStringValue(i));
          }
          System.out.println(" ");
          rs.next();
        }
      }
    }
    ***/
    // init and crawl
    try
    {
      m_iterator.init(folioDataBinder, m_manager, callback, options);
      m_iterator.iterate(true, null);
    }
    catch (DataException d)
    {
      throw new ServiceException(d);
    }
    // System.out.println("... in Folio Crawl Service Handler - adding to binder, number of nodes is "+folioResultSet.getNumRows());
    m_binder.addResultSet("FolioResults",folioResultSet);
  }
}